import { PluginOptions as GatsbyPluginOptions } from 'gatsby';
import { CreateOptions as FlexSearchCreateOptions } from 'flexsearch';
export declare type IndexableDocument = Record<string, unknown>;
export declare type Store = Record<string, unknown>;
export declare enum NodeType {
    LocalSearch = "LocalSearch"
}
export declare type Engine = 'flexsearch' | 'lunr';
interface NormalizerInput {
    errors?: unknown;
    data?: unknown;
}
export interface PluginOptions extends GatsbyPluginOptions {
    name: string;
    engine: Engine;
    engineOptions?: FlexSearchCreateOptions;
    ref?: string;
    index?: string[];
    store?: string[];
    query: string;
    normalizer: (input: NormalizerInput) => IndexableDocument[];
}
export {};
